/**
 * 
 */
package eos.agents;

import java.util.Map;
import eos.framework.Economy;
import eos.framework.Good;
import eos.models.Laborer;
import eos.models.Baseline2Model.Baseline2Laborer;
import static eos.models.Baseline2Model.*;

/**
 * @author madelson
 * 
 */
public class BL2LaborSCLaborer extends Baseline2Laborer {

    private static final double TARGET_FOOD_STOCK = 30.0,
            TARGET_MONEY_STOCK = 60.0;

    /**
     * @param economy
     * @param goods
     */
    public BL2LaborSCLaborer(Economy economy, Map<String, Good> goods) {
        super(economy, goods);
        // TODO Auto-generated constructor stub
    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * eos.models.Baseline2Model.Baseline2Laborer#baseLine2LaborerSubclassAct()
     */
    protected void baseLine2LaborerSubclassAct() {
        // bid on food
        double foodNeeded = this.foodMarket.getLastMarketPrice() <= 0.0 ? Laborer.EAT_AMOUNT
                : TARGET_FOOD_STOCK - this.food.getQuantity() + 0.25
                        * TARGET_FOOD_STOCK;
        if (foodNeeded > TARGET_FOOD_STOCK / 2.0) // a little more when desperate
            this.foodMarket.addBuyOffer(this, 2.0 * Laborer.EAT_AMOUNT,
                    1.01 * HISTORICAL_FOOD_PRICE);
        if (foodNeeded > 0.0)
            this.foodMarket
                    .addBuyOffer(this, foodNeeded, HISTORICAL_FOOD_PRICE);

        // bid on labor
        if (this.firms != null && this.firms.size() > 0) {
            double moneyNeeded = TARGET_MONEY_STOCK - this.money.getQuantity();
            if (moneyNeeded > 0.0)
                this.firms.get(0).requestTransfer(this.money.getName(),
                        moneyNeeded);
            return;
        }
        // otherwise, sell labor!
        if (this.laborMarket.getLastMarketPrice() <= 0.0) {
            this.laborMarket.addSellOffer(this, Laborer.LABOR_ALLOWANCE,
                    HISTORICAL_LABOR_PRICE);
            return;
        }
        // this.laborMarket.addSellOffer(this, Laborer.LABOR_ALLOWANCE / 2.0,
        // this.laborMarket.getLastMarketPrice());
        double f = 0.9;
        double modifier = (this.food.getQuantity() < 0.9 * TARGET_FOOD_STOCK) ? f
                : (this.food.getQuantity() > (1.0 / 0.9) * TARGET_FOOD_STOCK ? (1.0 / f)
                        : 1.0);
        this.laborMarket.addSellOffer(this, Laborer.LABOR_ALLOWANCE,
                this.laborMarket.getLastMarketPrice() * modifier);
    }

}
