package eos.io;

import eos.framework.*;
import java.util.*;

/**
 * Defines a set of Input methods which allow an Economy Object to be "built".
 * 
 * @author Michael Adelson
 */
public interface BuildableEconomy {

    /**
     * Add agents to the Economy.
     */
    void addAgents(Collection<? extends Agent> agents);

    /**
     * Add markets to the Economy.
     */
    void addMarkets(Collection<? extends Market> markets);
}
