package eos.io;

/**
 * DataPrinter for printing the current timestep of the simulation.
 * 
 * By Michael Adelson
 */
public class TimeStepDataPrinter implements DataPrinter {

    /**
     * Construct a TimeStepDataPrinter.
     */
    public TimeStepDataPrinter()
    {
        super();
    }
    
    /**
     * Calls this.getData(economy).
     */
    public String getCleanupData(DataOutputEconomy economy) {
        return this.getData(economy);
    }

    /**
     * Get economy's running timesteps.
     */
    public String getData(DataOutputEconomy economy) {
        return economy.getRunningTimeSteps() + "";
    }

    /* (non-Javadoc)
     * @see output.DataPrinter#getTitle(output.DataOutputEconomy)
     */
    public String getTitle(DataOutputEconomy economy) {
        return "Time Step";
    }

    /**
     * True.
     */
    public boolean isCSVCompatible() {
        return true;
    }

    /**
     * True.
     */
    public boolean isMultiRunCompatible() {
        return true;
    }

}
